commit 0c877d1c30ef1c5145817805ab944cddea61ad54
Author: Xionghu Luo <luoxhu@linux.ibm.com>
Date:   Thu Nov 4 02:23:03 2021

    rs6000: Fix incorrect fusion constraint [PR102991]
    
    gcc/ChangeLog:
    
    2021-11-05  Xionghu Luo  <luoxhu@linux.ibm.com>
    
            PR target/102991
            * config/rs6000/fusion.md: Regenerate.
            * config/rs6000/genfusion.pl: Fix incorrect clobber constraint.
    
    (cherry picked from commit 614b39757b8b61f70ac1c666edb7a01a5fc19cd4)

diff --git a/gcc/config/rs6000/genfusion.pl b/gcc/config/rs6000/genfusion.pl
index ac22852220e..0fef75bd516 100755
--- a/gcc/config/rs6000/genfusion.pl
+++ b/gcc/config/rs6000/genfusion.pl
@@ -265,7 +265,7 @@ sub gen_logical_addsubf
 (define_insn "*fuse_${inner_op}_${outer_name}"
   [(set (match_operand:${mode} 3 "${pred}" "=&0,&1,&${constraint},${constraint}")
         ${outer_exp})
-   (clobber (match_scratch:${mode} 4 "=X,X,X,&r"))]
+   (clobber (match_scratch:${mode} 4 "=X,X,X,&${constraint}"))]
   "(TARGET_P10_FUSION && $target_flag)"
   "@
    ${inner_op} %3,%1,%0\\;${outer_op} %3,${outer_32}

